Index: /cpp/tests/geometry_goals/f1.goal
===================================================================
--- /cpp/tests/geometry_goals/f1.goal	(revision 815)
+++ /cpp/tests/geometry_goals/f1.goal	(revision 816)
@@ -4,24 +4,24 @@
 p:sh=2, sx=0.05, sy=0.5, sz=0.05, vr=0.0, vb=0.0
 p:sh=2, sx=0.05, sy=0.05, sz=0.5, vr=0.0, 0.0
-p:y=-0.649750002977198, -0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
-p:y=-0.649750002977198, 0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
-p:y=0.649750002977198, -0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
-p:y=0.649750002977198, 0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
-p:4.009699, -0.649750002977198, -0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
-p:4.009699, -0.649750002977198, 0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
-p:4.009699, 0.649750002977198, -0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
-p:4.009699, 0.649750002977198, 0.200000002980232, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
-p:2.0048495, sh=2, sx=4.02960123031664, sy=0.05, sz=0.05, rz=0.0994291546863008, vg=0.0, 0.0
-p:2.0048495, sh=2, sx=0.05, sy=1.4986037809972, sz=0.05, rz=0.0994291546863008, vr=0.0, vb=0.0
-p:2.0048495, sh=2, sx=0.05, sy=0.05, sz=0.400000005960464, rz=0.0994291546863008, vr=0.0, 0.0
-p:0.3995, sh=3, sx=0.3995, sy=0.200000002980232, sz=0.200000002980232, rx=-1.5707963267949, rz=3.14159265358979
-p:0.798998347976005, -0.449749999996966, sh=3, sx=0.44975, sy=0.200000002980232, sz=0.200000002980232, rz=1.57079265358979
-p:1.163325, sh=3, sx=0.364325, sy=0.200000002980232, sz=0.200000002980232, rx=-1.5707963267949, rz=3.14159265358979
-p:1.879664, sh=3, sx=0.352014, sy=0.200000002980232, sz=0.200000002980232, rx=-1.5707963267949, rz=3.14159265358979
-p:2.23167643518891, -0.426006999997126, sh=3, sx=0.426007, sy=0.200000002980232, sz=0.200000002980232, rz=1.57079265358979
-p:2.657685, sh=3, sx=0.426007, sy=0.200000002980232, sz=0.200000002980232, rx=-1.5707963267949, rz=3.14159265358979
-p:3.5466955, sh=3, sx=0.4630035, sy=0.200000002980232, sz=0.200000002980232, rx=-1.5707963267949, rz=3.14159265358979
-p:2.23167643518891, 0.426006999997126, sh=3, sx=0.426007, sy=0.200000002980232, sz=0.200000002980232, rz=-1.57079265358979
-p:0.798998347976005, 0.449749999996966, sh=3, sx=0.44975, sy=0.200000002980232, sz=0.200000002980232, rz=-1.57079265358979
+p:y=-0.649749999996966, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:y=-0.649749999996966, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:y=0.649749999996966, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:y=0.649749999996966, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:4.009699, -0.649749999996966, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:4.009699, -0.649749999996966, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:4.009699, 0.649749999996966, -0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:4.009699, 0.649749999996966, 0.2, sh=1, sx=0.05, sy=0.05, sz=0.05, vb=0.0
+p:2.0048495, sh=2, sx=4.02960122972497, sy=0.05, sz=0.05, rz=0.0994291532144366, vg=0.0, 0.0
+p:2.0048495, sh=2, sx=0.05, sy=1.49860377187165, sz=0.05, rz=0.0994291532144366, vr=0.0, vb=0.0
+p:2.0048495, sh=2, sx=0.05, sy=0.05, sz=0.4, rz=0.0994291532144366, vr=0.0, 0.0
+p:0.3995, sh=3, sx=0.3995, sy=0.2, sz=0.2, rx=-1.5707963267949, rz=3.14159265358979
+p:0.798998347976005, -0.449749999996966, sh=3, sx=0.44975, sy=0.2, sz=0.2, rz=1.57079265358979
+p:1.163325, sh=3, sx=0.364325, sy=0.2, sz=0.2, rx=-1.5707963267949, rz=3.14159265358979
+p:1.879664, sh=3, sx=0.352014, sy=0.2, sz=0.2, rx=-1.5707963267949, rz=3.14159265358979
+p:2.23167643518891, -0.426006999997126, sh=3, sx=0.426007, sy=0.2, sz=0.2, rz=1.57079265358979
+p:2.657685, sh=3, sx=0.426007, sy=0.2, sz=0.2, rx=-1.5707963267949, rz=3.14159265358979
+p:3.5466955, sh=3, sx=0.4630035, sy=0.2, sz=0.2, rx=-1.5707963267949, rz=3.14159265358979
+p:2.23167643518891, 0.426006999997126, sh=3, sx=0.426007, sy=0.2, sz=0.2, rz=-1.57079265358979
+p:0.798998347976005, 0.449749999996966, sh=3, sx=0.44975, sy=0.2, sz=0.2, rz=-1.57079265358979
 j:0, 1, sh=1
 j:0, 2, sh=1