Index: /cpp/common/log.cpp
===================================================================
--- /cpp/common/log.cpp	(revision 840)
+++ /cpp/common/log.cpp	(revision 841)
@@ -5,5 +5,5 @@
 #include "log.h"
 #include <common/nonstd_stdio.h>
-#include "stl-util.h"
+#include "util-string.h"
 #include "Convert.h"
 
Index: /cpp/common/loggers/loggers.cpp
===================================================================
--- /cpp/common/loggers/loggers.cpp	(revision 840)
+++ /cpp/common/loggers/loggers.cpp	(revision 841)
@@ -4,5 +4,5 @@
 
 #include "loggers.h"
-#include <common/stl-util.h>
+#include <common/util-string.h>
 #include <string.h>
 
Index: /cpp/common/nonstd_stdio.cpp
===================================================================
--- /cpp/common/nonstd_stdio.cpp	(revision 840)
+++ /cpp/common/nonstd_stdio.cpp	(revision 841)
@@ -6,5 +6,5 @@
 #include "nonstd.h"
 #include "Convert.h" //utf8ToUtf16()
-#include <common/stl-util.h>
+#include <common/util-string.h>
 
 #ifdef _WIN32
Index: /cpp/common/virtfile/virtfile.cpp
===================================================================
--- /cpp/common/virtfile/virtfile.cpp	(revision 840)
+++ /cpp/common/virtfile/virtfile.cpp	(revision 841)
@@ -4,5 +4,5 @@
 
 #include "virtfile.h"
-#include <common/stl-util.h>
+#include <common/util-string.h>
 
 VirtFILE *VirtFILE::Vstdin = NULL;
Index: /cpp/frams/Makefile-SDK-files
===================================================================
--- /cpp/frams/Makefile-SDK-files	(revision 840)
+++ /cpp/frams/Makefile-SDK-files	(revision 841)
@@ -31,5 +31,5 @@
 PRINTFLOAT_OBJS=PrintFloat/Math.o PrintFloat/Dragon4.o PrintFloat/PrintFloat.o
 
-SDK_OBJS=frams/util/list.o frams/util/advlist.o frams/param/param.o frams/util/sstring.o frams/util/sstringutils.o frams/util/3d.o frams/vm/classes/3dobject.o frams/model/model.o frams/model/modelparts.o frams/neuro/neurolibrary.o frams/genetics/geno.o frams/genetics/genoconv.o frams/util/extvalue.o frams/vm/classes/collectionobj.o frams/util/hashtable.o common/log.o common/stl-util.o common/nonstd_stdio.o frams/util/callbacks.o frams/param/syntparam.o frams/util/multirange.o frams/util/multimap.o frams/param/paramtabobj.o common/loggers/loggers.o frams/param/paramobj.o frams/genetics/genooperators.o common/nonstd_math.o frams/util/validitychecks.o common/Convert.o frams/util/rndutil.o common/virtfile/stringfile.o $(PRINTFLOAT_OBJS)
+SDK_OBJS=frams/util/list.o frams/util/advlist.o frams/param/param.o frams/util/sstring.o frams/util/sstringutils.o frams/util/3d.o frams/vm/classes/3dobject.o frams/model/model.o frams/model/modelparts.o frams/neuro/neurolibrary.o frams/genetics/geno.o frams/genetics/genoconv.o frams/util/extvalue.o frams/vm/classes/collectionobj.o frams/util/hashtable.o common/log.o common/util-string.o common/util-file.o common/nonstd_stdio.o frams/util/callbacks.o frams/param/syntparam.o frams/util/multirange.o frams/util/multimap.o frams/param/paramtabobj.o common/loggers/loggers.o frams/param/paramobj.o frams/genetics/genooperators.o common/nonstd_math.o frams/util/validitychecks.o common/Convert.o frams/util/rndutil.o common/virtfile/stringfile.o $(PRINTFLOAT_OBJS)
 
 GEOMETRY_OBJS=frams/model/geometry/meshbuilder.o frams/model/geometry/modelgeometryinfo.o frams/model/geometry/geometryutils.o
Index: /cpp/frams/genetics/fF/fF_genotype.h
===================================================================
--- /cpp/frams/genetics/fF/fF_genotype.h	(revision 840)
+++ /cpp/frams/genetics/fF/fF_genotype.h	(revision 841)
@@ -7,5 +7,4 @@
 
 #include <stdio.h>
-#include "common/stl-util.h"
 #include <frams/param/param.h>
 
Index: /cpp/frams/genetics/genman.cpp
===================================================================
--- /cpp/frams/genetics/genman.cpp	(revision 840)
+++ /cpp/frams/genetics/genman.cpp	(revision 841)
@@ -8,5 +8,5 @@
 #include "common/log.h"
 #include "common/nonstd_math.h"
-#include "common/stl-util.h"
+#include "common/util-string.h"
 #include <common/loggers/loggers.h>
 
Index: /cpp/frams/genetics/geno.cpp
===================================================================
--- /cpp/frams/genetics/geno.cpp	(revision 840)
+++ /cpp/frams/genetics/geno.cpp	(revision 841)
@@ -6,5 +6,5 @@
 #include "genoconv.h"
 #include <common/loggers/loggers.h>
-#include <common/stl-util.h>
+#include <common/util-string.h>
 #include <frams/model/model.h>
 
Index: /cpp/frams/genetics/genoconv.cpp
===================================================================
--- /cpp/frams/genetics/genoconv.cpp	(revision 840)
+++ /cpp/frams/genetics/genoconv.cpp	(revision 841)
@@ -15,5 +15,5 @@
 #include "genoconv.h"
 #include <frams/util/multimap.h>
-#include <common/stl-util.h>
+#include <common/util-string.h>
 
 ///////////////////////////////////////////////////////////////////////////