Index: /cpp/frams/model/similarity/simil_model.cpp
===================================================================
--- /cpp/frams/model/similarity/simil_model.cpp	(revision 871)
+++ /cpp/frams/model/similarity/simil_model.cpp	(revision 872)
@@ -75,5 +75,5 @@
 	//Determines whether "fuzzy vertex degree" should be used.
 	//Currently "fuzzy vertex degree" is inactive.
-	isFuzzy = 0;
+	isFuzzy = false;
 	fuzzyDepth = 10;
 
@@ -81,5 +81,5 @@
 	wMDS = 0;
 	//Determines whether best matching should be saved using hungarian similarity measure.
-	saveMatching = 0;
+	saveMatching = false;
 }
 
@@ -105,5 +105,5 @@
 	{
 		logPrintf("ModelSimil", "EvaluateDistanceGreedy", LOG_ERROR, "NULL or invalid model pointer(s)");
-			return 0.0;
+		return 0.0;
 	}
 
@@ -139,6 +139,6 @@
 	if ((this->*pfMatchingFunction)() == 0)
 	{
-		logPrintf("ModelSimil", "EvaluateDistanceGreedy", LOG_ERROR, "Matching function error");
-			return 0.0;
+		logPrintf("ModelSimil", "EvaluateDistanceGreedy", LOG_ERROR, "The matching function returned 0");
+		return 0.0;
 	}
 
@@ -151,6 +151,6 @@
 		if (CountPartsDistance() == 0)
 		{
-			logPrintf("ModelSimil", "EvaluateDistanceGreedy", LOG_ERROR, "CountPartDistance() error");
-				return 0.0;
+			logPrintf("ModelSimil", "EvaluateDistanceGreedy", LOG_ERROR, "CountPartDistance()==0");
+			return 0.0;
 		}
 
@@ -562,5 +562,5 @@
 		}
 
-		if (m_aDegrees[i] != NULL && (isFuzzy != 1 || (m_Neighbours[i] != NULL && m_fuzzyNeighb[i] != NULL)))
+		if (m_aDegrees[i] != NULL && ((!isFuzzy) || (m_Neighbours[i] != NULL && m_fuzzyNeighb[i] != NULL)))
 		{
 			// wypelnij tablice zgodnie z sensem TDN[0] - orginalny index
@@ -600,6 +600,6 @@
 		else
 		{
-			logPrintf("ModelSimil", "EvaluateDistanceGreedy", LOG_ERROR, "Memory error");
-				return 0;
+			logPrintf("ModelSimil", "CreatePartInfoTables", LOG_ERROR, "Not enough memory?");
+			return 0;
 		}
 		// utworz tablice dla pozycji 3D Parts (wielkosc tablicy: liczba Parts organizmu)
@@ -931,5 +931,5 @@
 	int i;
 	int(*pfDegreeFunction) (const void*, const void*) = NULL;
-	pfDegreeFunction = (isFuzzy == 1) ? &CompareFuzzyDegrees : &CompareDegrees;
+	pfDegreeFunction = isFuzzy ? &CompareFuzzyDegrees : &CompareDegrees;
 	// sortowanie obu tablic wg stopni punktów - TDN[1]
 	for (i = 0; i < 2; i++)
@@ -943,5 +943,5 @@
 	// sprawdzenie wartosci parametru
 	DB(i = sizeof(TDN);)
-		int degreeType = (isFuzzy == 1) ? FUZZ_DEG : DEGREE;
+		int degreeType = isFuzzy ? FUZZ_DEG : DEGREE;
 
 	// sortowanie obu tablic m_aDegrees wedlug liczby neuronów i
@@ -2079,5 +2079,5 @@
 	{
 		logPrintf("ModelSimil", "EvaluateDistanceHungarian", LOG_ERROR, "NULL genotype pointer(s)");
-			return 0.0;
+		return 0.0;
 	}
 	// create models of objects to compare
@@ -2089,5 +2089,5 @@
 	{
 		logPrintf("ModelSimil", "EvaluateDistanceHungarian", LOG_ERROR, "NULL or invalid model pointer(s)");
-			return 0.0;
+		return 0.0;
 	}
 
@@ -2165,5 +2165,5 @@
 			{
 				dMinSimValue = dCurrentSim;
-				if (saveMatching == 1)
+				if (saveMatching)
 				{
 					minAssignment.clear();
@@ -2174,5 +2174,5 @@
 
 		dResult = dMinSimValue;
-		if (saveMatching == 1)
+		if (saveMatching)
 			std::copy(minAssignment.begin(), minAssignment.end(), assignment);
 	}
Index: /cpp/frams/model/similarity/simil_model.h
===================================================================
--- /cpp/frams/model/similarity/simil_model.h	(revision 871)
+++ /cpp/frams/model/similarity/simil_model.h	(revision 872)
@@ -77,5 +77,5 @@
 	/// Currently selected matching algorithm. Allowed values: 0 (more exact, slower), 1 (more greedy, faster). Details in https://doi.org/10.1007/978-3-030-16692-2_8
 	/// @sa EvaluateDistance
-	int matching_method;
+	paInt matching_method;
 
 	/// Table of weights for weighted distance function.
@@ -89,15 +89,15 @@
 
 	//for Zfixed = 1, the "z" (vertical) coordinates are not taken into account during PCA alignment
-	int fixedZaxis;
+	paInt fixedZaxis;
 
 	//Controls the depth of fuzzy neighbourhood 
 	int fuzzyDepth;
-	int isFuzzy;
+	bool isFuzzy;
 
 	//For wMDS = 1 weighted MDS with vertex degrees as weights is used for the alignment.
-	int wMDS;
+	paInt wMDS;
 
 	//For saveMatching = 1 the best matching found will be saved.
-	int saveMatching;
+	bool saveMatching;
 
 	/// Interface to local parameters