Index: cpp/frams/genetics/f4/f4_oper.cpp
===================================================================
--- cpp/frams/genetics/f4/f4_oper.cpp	(revision 896)
+++ cpp/frams/genetics/f4/f4_oper.cpp	(revision 899)
@@ -448,9 +448,9 @@
 		int relid = neuid - id;
 		nn->l1 = relid;
-		//nn->l1 = (int)(4.0f * (rnd01 - 0.5f));
+		//nn->l1 = (int)(4.0f * (rndDouble(1) - 0.5f));
 	}
 	// weight
 	nn->f1 = GenoOperators::mutateNeuProperty(nn->f1, NULL, -1);
-	//nn->f1 = 10.0f * (rnd01 - 0.5f);
+	//nn->f1 = 10.0f * (rndDouble(1) - 0.5f);
 }
 
@@ -485,9 +485,9 @@
 			nn->l1 = neuid - id;
 		}
-		//nn->l1 += (int)(2.0f * (rnd01 - 0.5f));
+		//nn->l1 += (int)(2.0f * (rndDouble(1) - 0.5f));
 		break;
 	case 2: // change weight
 		nn->f1 = GenoOperators::mutateNeuProperty(nn->f1, NULL, -1);
-		//nn->f1 += 1.0f * (rnd01 - 0.5f);
+		//nn->f1 += 1.0f * (rndDouble(1) - 0.5f);
 		break;
 	}
@@ -630,5 +630,5 @@
 
 // decide number of nodes to mutate
-n = (int)( 0.5f + rnd01 * maxToMut );
+n = (int)( 0.5f + rndDouble(1) * maxToMut );
 if (n<1) n=1;
 if (n>totNodes) n=totNodes;
Index: cpp/frams/genetics/f9/f9_oper.cpp
===================================================================
--- cpp/frams/genetics/f9/f9_oper.cpp	(revision 896)
+++ cpp/frams/genetics/f9/f9_oper.cpp	(revision 899)
@@ -5,5 +5,5 @@
 #include "f9_oper.h"
 #include "f9_conv.h"
-#include <common/nonstd.h> //rndUint, rnd01
+#include <common/nonstd.h> //rndUint, rndDouble
 
 
Index: cpp/frams/genetics/fF/fF_oper.cpp
===================================================================
--- cpp/frams/genetics/fF/fF_oper.cpp	(revision 896)
+++ cpp/frams/genetics/fF/fF_oper.cpp	(revision 899)
@@ -5,5 +5,5 @@
 #include "fF_oper.h"
 #include "fF_genotype.h"
-#include <common/nonstd.h> //rndUint, rnd01
+#include <common/nonstd.h> //rndUint, rndDouble
 
 
Index: cpp/frams/genetics/fT/fTest_oper.cpp
===================================================================
--- cpp/frams/genetics/fT/fTest_oper.cpp	(revision 896)
+++ cpp/frams/genetics/fT/fTest_oper.cpp	(revision 899)
@@ -4,5 +4,5 @@
 
 #include "fTest_oper.h"
-#include <common/nonstd.h> //randomN, rnd01
+#include <common/nonstd.h> //randomN, rndDouble
 
 /**
Index: cpp/frams/genetics/fn/fn_oper.cpp
===================================================================
--- cpp/frams/genetics/fn/fn_oper.cpp	(revision 896)
+++ cpp/frams/genetics/fn/fn_oper.cpp	(revision 899)
@@ -1,9 +1,9 @@
 // This file is a part of Framsticks SDK.  http://www.framsticks.com/
-// Copyright (C) 1999-2018  Maciej Komosinski and Szymon Ulatowski.
+// Copyright (C) 1999-2019  Maciej Komosinski and Szymon Ulatowski.
 // See LICENSE.txt for details.
 
 #include "fn_oper.h"
 #include "fn_conv.h"
-#include <common/nonstd.h> //rndUint, rnd01
+#include <common/nonstd.h> //rndUint, rndDouble
 
 
Index: cpp/frams/genetics/genooperators.cpp
===================================================================
--- cpp/frams/genetics/genooperators.cpp	(revision 896)
+++ cpp/frams/genetics/genooperators.cpp	(revision 899)
@@ -76,5 +76,5 @@
 }
 
-int GenoOperators::selectRandomProperty(Neuro* n)
+int GenoOperators::selectRandomProperty(Neuro *n)
 {
 	int neuext = n->extraProperties().getPropCount(),
@@ -129,7 +129,7 @@
 			if (strcmp(n, "fo") == 0 && strcmp(na, "Force") == 0) newval = CustomRnd(distrib_force); else
 			{
-		double mn, mx, df;
-		getMinMaxDef(&p, i, mn, mx, df);
-		newval = mutateCreep(p.type(i)[0], oldval, mn, mx, true);
+				double mn, mx, df;
+				getMinMaxDef(&p, i, mn, mx, df);
+				newval = mutateCreep(p.type(i)[0], oldval, mn, mx, true);
 			}
 	return true;
@@ -195,6 +195,6 @@
 		double v1 = p1[i];
 		double v2 = p2[i];
-		p1[i] = v1*proportion + v2*(1 - proportion);
-		p2[i] = v2*proportion + v1*(1 - proportion);
+		p1[i] = v1 * proportion + v2 * (1 - proportion);
+		p2[i] = v2 * proportion + v1 * (1 - proportion);
 	}
 }
@@ -208,14 +208,14 @@
 		double v1 = p1.getDouble(i1);
 		double v2 = p2.getDouble(i2);
-		p1.setDouble(i1, v1*proportion + v2*(1 - proportion));
-		p2.setDouble(i2, v2*proportion + v1*(1 - proportion));
+		p1.setDouble(i1, v1 * proportion + v2 * (1 - proportion));
+		p2.setDouble(i2, v2 * proportion + v1 * (1 - proportion));
 	}
 	else
 		if (type1 == 'd' && type2 == 'd')
 		{
-		int v1 = p1.getInt(i1);
-		int v2 = p2.getInt(i2);
-		setIntFromDoubleWithProbabilisticDithering(p1, i1, v1*proportion + v2*(1 - proportion));
-		setIntFromDoubleWithProbabilisticDithering(p2, i2, v2*proportion + v1*(1 - proportion));
+			int v1 = p1.getInt(i1);
+			int v2 = p2.getInt(i2);
+			setIntFromDoubleWithProbabilisticDithering(p1, i1, v1 * proportion + v2 * (1 - proportion));
+			setIntFromDoubleWithProbabilisticDithering(p2, i2, v2 * proportion + v1 * (1 - proportion));
 		}
 		else
@@ -232,7 +232,7 @@
 }
 
-NeuroClass* GenoOperators::getRandomNeuroClass()
-{
-	vector<NeuroClass*> active;
+NeuroClass *GenoOperators::getRandomNeuroClass()
+{
+	vector<NeuroClass *> active;
 	for (int i = 0; i < Neuro::getClassCount(); i++)
 		if (Neuro::getClass(i)->genactive)
@@ -241,7 +241,7 @@
 }
 
-NeuroClass* GenoOperators::getRandomNeuroClassWithOutput()
-{
-	vector<NeuroClass*> active;
+NeuroClass *GenoOperators::getRandomNeuroClassWithOutput()
+{
+	vector<NeuroClass *> active;
 	for (int i = 0; i < Neuro::getClassCount(); i++)
 		if (Neuro::getClass(i)->genactive && Neuro::getClass(i)->getPreferredOutput() != 0)
@@ -250,7 +250,7 @@
 }
 
-NeuroClass* GenoOperators::getRandomNeuroClassWithInput()
-{
-	vector<NeuroClass*> active;
+NeuroClass *GenoOperators::getRandomNeuroClassWithInput()
+{
+	vector<NeuroClass *> active;
 	for (int i = 0; i < Neuro::getClassCount(); i++)
 		if (Neuro::getClass(i)->genactive && Neuro::getClass(i)->getPreferredInputs() != 0)
@@ -259,7 +259,7 @@
 }
 
-NeuroClass* GenoOperators::getRandomNeuroClassWithOutputAndNoInputs()
-{
-	vector<NeuroClass*> active;
+NeuroClass *GenoOperators::getRandomNeuroClassWithOutputAndNoInputs()
+{
+	vector<NeuroClass *> active;
 	for (int i = 0; i < Neuro::getClassCount(); i++)
 		if (Neuro::getClass(i)->genactive && Neuro::getClass(i)->getPreferredOutput() != 0 && Neuro::getClass(i)->getPreferredInputs() == 0)
@@ -268,5 +268,5 @@
 }
 
-int GenoOperators::getRandomNeuroClassWithOutput(const vector<NeuroClass*>& NClist)
+int GenoOperators::getRandomNeuroClassWithOutput(const vector<NeuroClass *> &NClist)
 {
 	vector<int> allowed;
@@ -277,5 +277,5 @@
 }
 
-int GenoOperators::getRandomNeuroClassWithInput(const vector<NeuroClass*>& NClist)
+int GenoOperators::getRandomNeuroClassWithInput(const vector<NeuroClass *> &NClist)
 {
 	vector<int> allowed;
@@ -301,14 +301,14 @@
 }
 
-NeuroClass* GenoOperators::parseNeuroClass(char*& s)
+NeuroClass *GenoOperators::parseNeuroClass(char *&s)
 {
 	int maxlen = (int)strlen(s);
 	int NClen = 0;
 	NeuroClass *NC = NULL;
-	for (int i = 0; i<Neuro::getClassCount(); i++)
+	for (int i = 0; i < Neuro::getClassCount(); i++)
 	{
 		const char *ncname = Neuro::getClass(i)->name.c_str();
 		int ncnamelen = (int)strlen(ncname);
-		if (maxlen >= ncnamelen && ncnamelen>NClen && (strncmp(s, ncname, ncnamelen) == 0))
+		if (maxlen >= ncnamelen && ncnamelen > NClen && (strncmp(s, ncname, ncnamelen) == 0))
 		{
 			NC = Neuro::getClass(i);
@@ -320,5 +320,5 @@
 }
 
-Neuro* GenoOperators::findNeuro(const Model *m, const NeuroClass *nc)
+Neuro *GenoOperators::findNeuro(const Model *m, const NeuroClass *nc)
 {
 	if (!m) return NULL;
@@ -328,5 +328,5 @@
 }
 
-int GenoOperators::neuroClassProp(char*& s, NeuroClass *nc, bool also_v1_N_props)
+int GenoOperators::neuroClassProp(char *&s, NeuroClass *nc, bool also_v1_N_props)
 {
 	int len = (int)strlen(s);
@@ -335,9 +335,9 @@
 	{
 		Param p = nc->getProperties();
-		for (int i = 0; i<p.getPropCount(); i++)
+		for (int i = 0; i < p.getPropCount(); i++)
 		{
 			const char *n = p.id(i);
 			int l = (int)strlen(n);
-			if (len >= l && l>Len && (strncmp(s, n, l) == 0)) { I = 100 + i; Len = l; }
+			if (len >= l && l > Len && (strncmp(s, n, l) == 0)) { I = 100 + i; Len = l; }
 			if (also_v1_N_props) //recognize old properties symbols /=!
 			{
@@ -352,9 +352,9 @@
 	Neuro n;
 	Param p = n.extraProperties();
-	for (int i = 0; i<p.getPropCount(); i++)
+	for (int i = 0; i < p.getPropCount(); i++)
 	{
 		const char *n = p.id(i);
 		int l = (int)strlen(n);
-		if (len >= l && l>Len && (strncmp(s, n, l) == 0)) { I = i; Len = l; }
+		if (len >= l && l > Len && (strncmp(s, n, l) == 0)) { I = i; Len = l; }
 	}
 	s += Len;
@@ -389,7 +389,7 @@
 }
 
-char* GenoOperators::strchrn0(const char *str, char ch)
-{
-	return ch == 0 ? NULL : strchr((char*)str, ch);
+char *GenoOperators::strchrn0(const char *str, char ch)
+{
+	return ch == 0 ? NULL : strchr((char *)str, ch);
 }
 
@@ -398,3 +398,2 @@
 	return isupper(firstchar) || firstchar == '|' || firstchar == '@' || firstchar == '*';
 }
-
Index: cpp/frams/genetics/genooperators.h
===================================================================
--- cpp/frams/genetics/genooperators.h	(revision 896)
+++ cpp/frams/genetics/genooperators.h	(revision 899)
@@ -198,5 +198,4 @@
 	static NeuroClass* getRandomNeuroClassWithInput(); ///<returns random neuroclass with input or NULL when no active classes.
 	static NeuroClass* getRandomNeuroClassWithOutputAndNoInputs(); ///<returns random sensor or NULL when no active classes.
-	static NeuroClass* getRandomSensorProb(float prob); ///<returns random sensor (only-output neuron class) with presented probability or NULL. \e prob probability of picking neuron class.
 	static int getRandomNeuroClassWithOutput(const vector<NeuroClass*>& NClist); ///<returns index of random NeuroClass from the NClist or -1 (no neurons on the list that provide output) \e NClist list of available neuron classes
 	static int getRandomNeuroClassWithInput(const vector<NeuroClass*>& NClist); ///<returns index of random NeuroClass from the NClist or -1 (no neurons on the list that want input(s)) \e NClist list of available neuron classes